# **产品常见问题**

* **什么是 MatrixOne？**

MatrixOne是一款面向未来的超融合异构云原生数据库，通过超融合数据引擎支持事务/分析/流处理等混合工作负载，通过异构云原生架构支持跨机房协同/多地协同/云边协同。MatrixOne希望简化数据系统开发和运维的成本，消减复杂系统间的数据碎片，打破数据融合的各种边界。  
想了解更多关于MatrixOne的信息，您可以浏览[MatrixOne简介](../Overview/matrixone-introduction.md)。

* **MatrxOne 支持哪些应用？**

  MatrixOne为用户提供了极致的HTAP服务，MatrixOne可以被应用在企业数据中台，大数据分析等场景中。

* **MatrixOne 是基于 MySQL 或者其他数据库开发的吗？**

 MatrixOne 是一个从零打造的全新数据库。MatrixOne 兼容 MySQL 的部分语法与语义，并且在未来将会产生更多与 MySQL 不同的语义，以便我们将之打造为一款更强大的超融合数据库。
 关于与 MySQL 的兼容性，您可参见[MySQL兼容性](../Overview/mysql-compatibility.md)。

* **MatrixOne使用什么编程语言开发的？**

  目前，我们主要使用 **Golang** 作为最主要的编程语言。

* **MatrixOne 可以在什么操作系统上部署？**

  MatrixOne支持在 Linux 与 MacOS 系统上部署。 更多信息，参见[部署常见问题](deployment-faqs.md).

* **MatrixOne 都支持哪些数据类型？**

  有关数据类型的更多信息，参见[MatrixOne 数据类型](../Reference/Data-Types/data-types.md)。

* **我可以在哪里部署 MatrixOne？**

  MatrixOne 可以本地部署、公共云、私有云或 kubernetes 上。

* **可以参与贡献 MatrixOne 项目吗？**

  MatrixOne 是一个完全在 Github 上进行的开源项目，欢迎所有开发者的贡献。更多信息，参见我们的[贡献指南](../Contribution-Guide/make-your-first-contribution.md)。

* **除了官方文档，是否还有其他 MatrixOne 知识获取途径？**

  目前，[MatrixOne 文档](https://docs.matrixorigin.io/)是获取 MatrixOne 相关知识最重要、最及时的途径。此外，我们在 Slack 和微信还有一些技术交流群。如有任何需求，请联系[opensource@matrixorigin.io](mailto:opensource@matrixorigin.io)。
