# **DATE()**

## **函数说明**

将date或者datetime格式的输入中的日期部分截取出来。

## **函数语法**

```
> DATE(expr)
```

## **参数释义**

|  参数   | 说明  |
|  ----  | ----  |
| expr  | 必要参数。需要提取日期的date或者datetime格式的输入值 |

## **示例**

```sql
> drop table if exists t1;
> create table t1(a date, b datetime);
> insert into t1 values('2022-01-01','2022-01-01 01:01:01');
> insert into t1 values('2022-01-01','2022-01-01 01:01:01');
> insert into t1 values(20220101,'2022-01-01 01:01:01');
> insert into t1 values('2022-01-02','2022-01-02 23:01:01');
> insert into t1 values('2021-12-31','2021-12-30 23:59:59');
> insert into t1 values('2022-06-30','2021-12-30 23:59:59');
> select date(a),date(b) from t1;
+------------+------------+
| date(a)    | date(b)    |
+------------+------------+
| 2022-01-01 | 2022-01-01 |
| 2022-01-01 | 2022-01-01 |
| 2022-01-01 | 2022-01-01 |
| 2022-01-02 | 2022-01-02 |
| 2021-12-31 | 2021-12-30 |
| 2022-06-30 | 2021-12-30 |
+------------+------------+
> select date(a),date(date(a)) as dda from t1;
+------------+------------+
| date(a)    | dda        |
+------------+------------+
| 2022-01-01 | 2022-01-01 |
| 2022-01-01 | 2022-01-01 |
| 2022-01-01 | 2022-01-01 |
| 2022-01-02 | 2022-01-02 |
| 2021-12-31 | 2021-12-31 |
| 2022-06-30 | 2022-06-30 |
+------------+------------+
```

## **限制**

目前date格式只支持`yyyy-mm-dd` 和 `yyyymmdd`的数据格式。  
