# **运算符概述**

## [**算数运算符**](operators/arithmetic-operators/arithmetic-operators-overview.md)

| 名称 | 描述|
|---|-----|
| [%,MOD](operators/arithmetic-operators/mod.md) | 取余 |
| [*](operators/arithmetic-operators/multiplication.md) | 乘法 |
| [+](operators/arithmetic-operators/addition.md) | 加法 |
| [-](operators/arithmetic-operators/minus.md) | 减法 |
| [-](operators/arithmetic-operators/unary-minus.md) | 负号 |
| [/](operators/arithmetic-operators/division.md) | 除法 |
| [DIV](operators/arithmetic-operators/div.md) | 用于整数相除 |

## [**赋值运算符**](operators/assignment-operators/assignment-operators-overview.md)

| 名称 | 描述|
|---|-----|
| [=](operators/assignment-operators/equal.md) | 等于运算符，用于赋值 |

## [**强制转换函数和运算符**](operators/cast-functions-and-operators/cast-functions-and-operators-overview.md)

| 名称 | 描述|
|---|-----|
| [CAST()](operators/cast-functions-and-operators/cast.md) | 将值转换为特定类型，用于小数转数值和字符型 |
| [CONVERT()](operators/cast-functions-and-operators/convert.md) | 将值转换为特定类型，用于日期和时间值、小数之间进行转换 |

## [**比较函数和运算符**](operators/comparison-functions-and-operators/comparison-functions-and-operators-overview.md)

| 名称 | 描述|
|---|-----|
| [>](operators/comparison-functions-and-operators/greater-than.md) | 大于 |
| [>=](operators/comparison-functions-and-operators/greater-than-or-equal.md) | 大于等于 |
| [<](operators/comparison-functions-and-operators/less-than.md) | 小于 |
| [<>,!=](operators/comparison-functions-and-operators/not-equal.md) | 不等于 |
| [<=](operators/comparison-functions-and-operators/less-than-or-equal.md) | 小于等于 |
| [=](operators/comparison-functions-and-operators/assign-equal.md) | 等于 |
| [BETWEEN ... AND ...](operators/comparison-functions-and-operators/between.md) | 在两值之间 |
| [IN()](operators/comparison-functions-and-operators/in.md) | 在集合中 |
| [IS](operators/comparison-functions-and-operators/is.md) | 测试值是否是布尔值，若是布尔值，则返回“true” |
| [IS NOT](operators/comparison-functions-and-operators/is-not.md) | 测试值是否是布尔值，IS 的否定用法 |
| [IS NOT NULL](operators/comparison-functions-and-operators/is-not-null.md) | 不为空 |
| [IS NULL](operators/comparison-functions-and-operators/is-null.md) | 为空 |
| [LIKE](operators/comparison-functions-and-operators/like.md) | 模糊匹配 |
| [NOT BETWEEN ... AND ...](operators/comparison-functions-and-operators/not-between.md) | 不在两值之间 |
| [NOT LIKE](operators/comparison-functions-and-operators/not-like.md) | 模糊匹配，Like的否定用法 |

## [**控制流函数**](operators/flow-control-functions/flow-control-functions-overview.md)

| 名称 | 描述|
|---|-----|
| [CASE](operators/flow-control-functions/case.md) | Case 运算符 |
| [IF()](operators/flow-control-functions/function_if.md) | If/else 语句 |

## [**逻辑运算符**](operators/logical-operators/logical-operators-overview.md)

| 名称 | 描述|
|---|-----|
| [AND,&&](operators/logical-operators/and.md) | 逻辑与 |
| [NOT,!](operators/logical-operators/not.md) | 逻辑非 |
| [OR](operators/logical-operators/or.md) | 逻辑或 |
| [XOR](operators/logical-operators/xor.md) | 逻辑异或 |
