# **MatrixOne Introduction**

MatrixOne is a future-oriented hyperconverged cloud & edge native DBMS that supports transactional, analytical, and streaming workload with a simplified and distributed database engine working across multiple datacenters, clouds, edges, and other heterogenous infrastructures.

## **Key Features**

### **Hyperconverged Engine**

* **Monolithic Engine**

     A monolithic database engine is designed to support hybrid workloads: transactional, analytical, streaming, time-series, machine learning, etc.

* **Built-in Streaming Engine**

     With the built-in streaming engine, MatrixOne supports in-database streaming processing by groundbreaking incremental materialized view maintenance.

### **Cloud & Edge Native**

* **Real Infrastructure Agnostic**

     MatrixOne supports seamless workload migration and bursting among different locations and infrastructures.

* **Multi-site Active/Active**

     MatrixOne provides industry-leading latency control with optimized consistency protocol.

### **Extreme Performance**

* **High Performance**

     Accelerated queries supported by patented vectorized execution as well as optimal computation.

* **Strong Consistency**

     MatrixOne introduces a global, high-performance distributed transaction protocol across storage engines.

* **High Scalability**

     Seamless and non-disruptive scaling by disaggregated storage and compute.   

## **User Values**

* **Simplify Database Management and Maintenance**

     To solve the problem of high and unpredictable costs of the database selection process, management & maintenance due to database overabundance, MatrixOne's all-in-one architecture will significantly simplify database management and maintenance. A single database can serve multiple data applications.

* **Reduce Data Fragmentation and Inconsistency**

     Data flow and copy between different databases make data sync and consistency increasingly difficult. The unified and incrementally materialized view of MatrixOne allows the downstream to support real-time upstream updates, and achieve end-to-end data processing without redundant ETL process.

* **Decoupling Data Architecture From Infrastructure**

     Currently the architecture design across different infrastructures is complicated, causing new data silos between cloud and edge, cloud and on-premise. MatrixOne is designed with a unified architecture to support simplified data management and operations across different types of infrastructures.

* **Extremely Fast Complex Query Performance**

     Poor business agility is a result of slow complex queries and redundant intermediate tables in current data warehousing solutions. MatrixOne  supports blazing-fast experience even for star and snowflake schema queries, improving business agility by real-time analytics.

* **An Solid OLTP-like OLAP Experience**

     Current data warehousing solutions have the following problems such as high latency and absence of immediate visibility for data updates. MatrixOne brings OLTP (Online Transactional Processing) level consistency and high availability to CRUD operations in OLAP (Online Analytical Processing).

* **Seamless and Non-disruptive Scaling**

     It is difficult to balance performance and scalability to achieve an optimum price-performance ratio in current data warehousing solutions. MatrixOne's disaggregated storage and compute architecture makes it fully automated and efficient to scale in/out and up/down without disrupting applications.

## **Learn More**

This page outlines the overall introduction of MatrixOne. For information on other options that are available when you what to know more about MatrixOne product design, see the following:

* [MatrixOne Architecture](matrixone-architecture.md)
