# **Operators Overview**

## [**Arithmetic Operators**](operators/arithmetic-operators/arithmetic-operators-overview.md)

| Name | Description|
|---|-----|
| [%,MOD](operators/arithmetic-operators/mod.md) | Modulo operator |
| [*](operators/arithmetic-operators/multiplication.md) | Multiplication operator |
| [+](operators/arithmetic-operators/addition.md) | Addition operator |
| [-](operators/arithmetic-operators/minus.md) | Minus operator |
| [-](operators/arithmetic-operators/unary-minus.md) | Change the sign of the argument |
| [/](operators/arithmetic-operators/division.md) | Division operator |
| [DIV](operators/arithmetic-operators/div.md) | Integer division |

## [**Assignment Operators**](operators/assignment-operators/assignment-operators-overview.md)

| Name | Description|
|---|-----|
| [=](operators/assignment-operators/equal.md) | Equal operator |

## [**Cast Functions and Operators**](operators/cast-functions-and-operators/cast-functions-and-operators-overview.md)

| Name | Description|
|---|-----|
| [CAST()](operators/cast-functions-and-operators/cast.md) | Cast a value as a certain type |
| [CONVERT()](operators/cast-functions-and-operators/convert.md) | Cast a value as a certain type |

## [**Comparison Functions and Operators**](operators/comparison-functions-and-operators/comparison-functions-and-operators-overview.md)

| Name | Description|
|---|-----|
| [>](operators/comparison-functions-and-operators/greater-than.md) | Greater than operator |
| [>=](operators/comparison-functions-and-operators/greater-than-or-equal.md) | Greater than or equal operator |
| [<](operators/comparison-functions-and-operators/less-than.md) | Less than operator |
| [<>,!=](operators/comparison-functions-and-operators/not-equal.md) | Not equal operator |
| [<=](operators/comparison-functions-and-operators/less-than-or-equal.md) | Less than or equal operator |
| [=](operators/comparison-functions-and-operators/assign-equal.md) | Equal operator |
| [BETWEEN ... AND ...](operators/comparison-functions-and-operators/between.md) | Whether a value is within a range of values |
| [IN()](operators/comparison-functions-and-operators/in.md) | Whether a value is within a set of values |
| [IS](operators/comparison-functions-and-operators/is.md) | Test a value against a boolean |
| [IS NOT](operators/comparison-functions-and-operators/is-not.md) | Test a value against a boolean |
| [IS NOT NULL](operators/comparison-functions-and-operators/is-not-null.md) | NOT NULL value test |
| [IS NULL](operators/comparison-functions-and-operators/is-null.md) | NULL value test |
| [LIKE](operators/comparison-functions-and-operators/like.md) | Simple pattern matching |
| [NOT BETWEEN ... AND ...](operators/comparison-functions-and-operators/not-between.md) | Whether a value is not within a range of values |
| [NOT LIKE](operators/comparison-functions-and-operators/not-like.md) | Negation of simple pattern matching |

## [**Flow Control Functions**](operators/flow-control-functions/flow-control-functions-overview.md)

| Name | Description|
|---|-----|
| [CASE](operators/flow-control-functions/case.md) | Case operator |
| [IF()](operators/flow-control-functions/function_if.md) | If/else construct |

## [**Logical Operators**](operators/logical-operators/logical-operators-overview.md)

| Name | Description|
|---|-----|
| [AND,&&](operators/logical-operators/and.md) | Logical AND |
| [NOT,!](operators/logical-operators/not.md) | Negates value |
| [OR](operators/logical-operators/or.md) | Logical OR |
| [XOR](operators/logical-operators/xor.md) | Logical XOR |
