# **MatrixOne v0.5.0 Release Notes**

We are excited to announce MatrixOne 0.5.0 release. In this release, MatrixOne has a stand-alone columnar storage engine which can support HTAP workloads. Cheers!

## Docker

```
docker pull matrixorigin/matrixone:0.5.0
```

## Features

- Support ACID transaction with a Snapshot Isolation level.
- Support UPDATE, DELETE and INSERT INTO ... SELECT ... statement.
- Support BOOL and Timestamp data type.
- Support LEFT / RIGHT / OUTER / NATURAL JOIN.
- Support Having expression.
- Support subquery.
- Support Common Table Expression.
- Support CASE ... WHEN expression.
- Support Interval expression.
- Support Explain plan tree.
- Support new aggregate function: any_value
- Lots of new functions are supported.

## Known issues

- Hotfix on 0.5.0 may cause data format incompatable.
- 'Too many open files' error might be issued when user insert/update/delete data or create/drop table frequently. User need to increase the 'max open files' to resolve the issue.
- Running 1GB TPCH benchmark test with memory less than 64GB may result in an out of memory error.
- Loading large size of CSV file than 100GB might lead to system hanging. #3858
- Mixed TP and AP work loads running for a long time, might cause system panic. #3947 #3961

## Contributors

This release includes 811 commits by 73 authors.

### New Contributors

* @lawrshen
* @lyfer233
* @wuliuqii
* @ericsyh
* @dongdongyang33
* @aylei
* @richelleguice
* @aressu1985
* @mklzl

We appreciate your contribution! Welcome to MatrixOne community.

## Full Changelog

<https://github.com/matrixorigin/matrixone/compare/v0.4.0...v0.5.0>
